import React, { useState, useCallback } from 'react';
import ReactDOM from 'react-dom';

const width = 960;
const height = 500;
const boundry = 10;
const movementStep = 5;

var circleRadius = 10;
var fillColor = "black";
var colorInt = 0;

var upPressed = false;
var downPressed = false;
var rightPressed = false;
var leftPressed = false;
var spacePressed = false;
var minusPressed = false;
var plusPressed = false;
var toggleDraw = false;
var cPressed = false;

var xPos = width / 2;
var yPos = height / 2;

var dMes = '';

const initialParameters = 
      { 
        x: xPos, 
        y: yPos, 
        d: dMes, 
        cr: circleRadius, 
        color: fillColor
      };

const App = () => {
  const [parameters, setParameters] = useState(initialParameters);

  document.addEventListener(
    'keydown',
    event => {
      switch (event.key) 
      {
        case 'd':
        case 'D':
        case 'ArrowRight':
          if (!rightPressed && xPos < width - boundry) 
          {
            rightPressed = true;
            console.log('right');

            if (toggleDraw) 
            {
              addToLine(xPos, yPos);
            }

            setParameters
            (
              {
                x: (xPos += movementStep),
                y: yPos,
                d: dMes,
                cr: circleRadius,
                color: fillColor
              }
            );
          }
          break;
          
        case 'a':
        case 'A':
        case 'ArrowLeft':
          if (!leftPressed && xPos > boundry) 
          {
            leftPressed = true;
            console.log('left');

            if (toggleDraw) 
            {
              addToLine(xPos, yPos);
            }
            setParameters
            (
              {
                x: (xPos -= movementStep),
                y: yPos,
                d: dMes,
                cr: circleRadius,
                color: fillColor
              }
            );
          }
          break;
          
        case 'w':
        case 'W':
        case 'ArrowUp':
          if (!upPressed && yPos > boundry) 
          {
            upPressed = true;
            console.log('Up');

            if (toggleDraw) 
            {
              addToLine(xPos, yPos);
            }

            setParameters
            (
              {
                x: xPos,
                y: (yPos -= movementStep),
                d: dMes,
                cr: circleRadius,
                color: fillColor
              }
            );
          }
          break;
          
        case 's':
        case 'S':
        case 'ArrowDown':
          if (!downPressed && yPos < height - boundry) 
          {
            downPressed = true;
            console.log('Down');

            if (toggleDraw) 
            {
              addToLine(xPos, yPos);
            }

            setParameters
            (
              {
                x: xPos,
                y: (yPos += movementStep),
                d: dMes,
                cr: circleRadius,
                color: fillColor
              }
            );
          }
          break;
          
        case 'c':
        case 'C':
          if(!cPressed)
          {
            if(colorInt >= 6)
            {
              colorInt = 0;
            }
            cPressed = true;
           	cycleColors(colorInt++);
            setParameters
            (
              {
                x: xPos,
                y: yPos,
                d: dMes,
                cr: circleRadius,
                color: fillColor
              }
            );
          }
          break;
          
        case ' ':
          if(!spacePressed)
          {
            if (!toggleDraw) 
            {
              toggleDraw = true;
              dMes = 'M ' + xPos + ' ' + yPos;
            } 
            else 
            {
              toggleDraw = false;
            }
            spacePressed = true;
          }
          break;
        
        case '-':
          if((!minusPressed) && (circleRadius > 2))
          {
            minusPressed = true;
          	setParameters
            (
              {
                x: xPos,
                y: yPos,
                d: dMes,
                cr: --circleRadius,
                color: fillColor
              }
            );
          }
        	break;
          
        case '+':
          if(!plusPressed)
          {
            plusPressed = true;
          	setParameters
            (
              {
                x: xPos,
                y: yPos,
                d: dMes,
                cr: ++circleRadius,
                color: fillColor
              }
            );
          }
          break;
          
        default:
          //Determine what was pressed
          console.log(event.key + ' was pressed');
          break;
      }
    },
    [setParameters]
  );

  document.addEventListener('keyup', event => {
    switch (event.key) 
    {
      case 'd':
      case 'D':
      case 'ArrowRight':
       	rightPressed = false;
        break;
        
      case 'a':
      case 'A':
      case 'ArrowLeft':
        leftPressed = false;
        break;
        
      case 'w':
      case 'W':
      case 'ArrowUp':
        upPressed = false;
        break;
        
      case 's':
      case 'S':
      case 'ArrowDown':
        downPressed = false;
        break;
      
      case 'c':
      case 'C':
        cPressed = false;
        break;
        
      case '-':
        minusPressed = false;
        break;
        
      case '+':
        plusPressed = false;
        break;
        
      case ' ':
        spacePressed = false;
        break;
    }
  });

  function addToLine(x, y) 
  {
    dMes += ' L ' + x + ' ' + y;
    //console.log("New message: " + dMes);
  }
  
  function cycleColors(colorInt)
  {
   	 switch(colorInt)
     {
       case 0:
         fillColor = "orange";
         break;
       case 1:
         fillColor = "purple";
         break;
       case 2:
         fillColor = "yellow";
         break;
       case 3:
         fillColor = "red";
         break;
       case 4:
         fillColor = "blue";
         break;
       case 5:
       default:
         fillColor = "black";
         break;
     }
  }

  return (
    // <svg width={width} height={height} onKeyPress={handleKeyPress}>
    <svg width={width} height={height}>
      <circle cx={parameters.x} cy={parameters.y} r={parameters.cr} fill={parameters.color} />

      <path
        d={parameters.d}
        stroke={parameters.color}
        stroke-width={parameters.cr}
        fill="none"
      />
    </svg>
  );
};

const rootElement = document.getElementById('root');
ReactDOM.render(<App />, rootElement);
